package com.yunzhi.nanyang.service.impl;

import com.yunzhi.nanyang.common.Constants;
import com.yunzhi.nanyang.entity.SysLogin;
import com.yunzhi.nanyang.entity.SysRolePermission;
import com.yunzhi.nanyang.entity.SysUser;
import com.yunzhi.nanyang.entity.SysUserRole;
import com.yunzhi.nanyang.mapper.SysLoginMapper;
import com.yunzhi.nanyang.mapper.SysRolePermissionMapper;
import com.yunzhi.nanyang.mapper.SysUserMapper;
import com.yunzhi.nanyang.mapper.SysUserRoleMapper;
import com.yunzhi.nanyang.shiro.realms.manager.IManagerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Set;

@Service
public class ManagerServiceImpl implements IManagerService {

    @Autowired
    SysLoginMapper sysLoginMapper;

    @Autowired
    SysUserMapper sysUserMapper;

    @Autowired
    SysUserRoleMapper sysUserRoleMapper;

    @Autowired
    SysRolePermissionMapper sysRolePermissionMapper;

    @Override
    public Boolean verify(String id) {
        SysLogin sysLogin = sysLoginMapper.selectById(id);
        if (null == sysLogin || sysLogin.getStatus() != Constants.STATUS_NORMAL) {
            return false;
        }

        return true;
    }

    @Override
    public Set<String> getRolesByLoginId(String id) {
        SysLogin sysLogin = sysLoginMapper.selectById(id);
        return sysUserRoleMapper.getRoleByUser(sysLogin.getUserId());
    }

    @Override
    public Set<String> getPermissionsLoginId(String id) {
        SysLogin sysLogin = sysLoginMapper.selectById(id);
        return sysRolePermissionMapper.getPermissionByUser(sysLogin.getUserId());
    }

}
